// Copyright 2022 schukai GmbH. All rights reserved.
// Use of this source code is governed by a AGPL-3.0
// license that can be found in the LICENSE file.

package xflags

import (
	"github.com/stretchr/testify/assert"
	"testing"
)

func TestGetValues(t *testing.T) {
	s := &Settings[CmdTest1]{
		definitions: CmdTest1{},
	}
	assert.Equal(t, CmdTest1{}, s.GetValues())
}

func TestInitCommands(t *testing.T) {
	s := &Settings[CmdTest1]{
		definitions: CmdTest1{},
	}

	s.initCommands("test")
	assert.Equal(t, 0, len(s.errors))
	assert.Equal(t, "test", s.command.name)
	assert.Equal(t, 1, len(s.command.commands))
	assert.Equal(t, 3, len(s.command.tagMapping))
}
