// Copyright 2022 schukai GmbH. All rights reserved.
// Use of this source code is governed by a AGPL-3.0
// license that can be found in the LICENSE file.

package xflags

import "reflect"

// SetShadow sets the shadow struct for the flag configuration.
func (s *Settings[C]) SetShadow(shadow any) *Settings[C] {

	if reflect.TypeOf(shadow).Kind() != reflect.Ptr {
		s.errors = append(s.errors, ShadowMustBePointerError)
		return s
	}

	if reflect.TypeOf(shadow).Elem().Kind() != reflect.Struct {
		s.errors = append(s.errors, ShadowMustBePointerError)
		return s
	}

	s.shadow = shadow
	return s
}
